<template>
  <sui-modal
    v-model="visible"
    size="mini"
    class="confirm"
    :animation-duration="1"
    @displayChanged="onDisplayChanged"
    v-dom-move
    v-scroll-lock="verifyMailModalShow">
    <i
      class="close icon"
      @click="hideModal"/>
    <div class="header white"/>
    <div class="content">
      <div class="title">
        Подтвердите свой e-mail
        <div class="text">На ваш e-mail выслано письмо <br>с кодом подтверждения</div>
      </div>
      <div class="ui form">
        <div class="field">
          <label>Введите код</label>
          <div class="ui input">
            <masked-input
              v-model.lazy="code"
              @input="changeVerifyCode($event)"
              :mask="codeMask"
              :masked="true"
              placeholder="Введите код"
              type="text"/>
          </div>
        </div>
        <div
          v-if="errorMessage"
          class="field">
          {{ errorMessage }}
        </div>
        <div class="field">
          <button
            type="button"
            class="ui button blue small fluid"
            @click="repeatSendVerifyCode"
            :disabled="disabled">
            Выслать код еще раз
          </button>
        </div>
      </div>
    </div>
  </sui-modal>
</template>

<script>
import { TheMask } from 'vue-the-mask';

export default {
  name: 'VerifyMail',
  components: {
    'masked-input': TheMask,
  },
  model: {
    prop: 'verifyMailModalShow',
    event: 'change',
  },
  props: {
    verifyMailModalShow: {
      type: Boolean,
      required: true,
    },
    errorMessage: {
      type: String,
      required: true,
    },
  },
  data() {
    return {
      code: null,
      codeMask: '#####',
      incorrectCode: {
        show: false,
        message: {
          type: String,
          default: '',
        },
      },
      disabled: true,
    };
  },
  computed: {
    visible: {
      get() {
        return this.verifyMailModalShow;
      },
      set(newVal) {
        if (newVal) {
          this.$emit('change', true);
        } else {
          this.hideModal();
        }
      },
    },
  },
  methods: {
    onDisplayChanged() {
      this.unDisabled();
      this.code = null;
    },
    repeatSendVerifyCode() {
      this.disabled = true;
      this.$emit('sendAgain');
      this.unDisabled();
    },
    hideModal() {
      this.$emit('close');
      this.$emit('change', false);
    },
    changeVerifyCode(value) {
      if (value && value.length === 5) {
        this.$emit('input', value);
      }
    },
    unDisabled() {
      setTimeout(() => { this.disabled = false; }, 5000);
    },
  },
};
</script>

<style scoped lang="scss">
  .ui.modal {
    > .content {
      max-width: 18rem;
      margin: 0 auto;
      padding: 0 2rem 2rem;
      @media screen and (max-width: 980px) {
        padding-bottom: 2.5rem !important;
      }

      .title {
        display: block;
        font-size: 1rem;
        line-height: 1.3;
        font-weight: 500;
        text-align: center;
        @media screen and (max-width: 980px) {
          font-size: 1.125rem;
        }

        .text {
          padding: 0.5rem 0 1.5rem;
        }
      }

      .text {
        display: block;
        margin: 0;
        font-size: 0.8125rem;
        line-height: 1.3;
        font-weight: 400;
        color: #4a4a4a;
        text-align: center;
        padding: 0;
        @media screen and (max-width: 980px) {
          font-size: 0.9375rem;
        }
      }
    }
  }

</style>
